﻿using Vintagestory.API.Common;
using Vintagestory.GameContent;

namespace simpleMobFootSteps
{

    public class AiTaskLoudDrifterWander : AiTaskWander
    {

        public AssetLocation stepSound = new AssetLocation("game", "sounds/walk/lava");
        public float stepTimer = new float();
        

        public override bool ContinueExecute(float dt)
        {
            stepTimer += dt;

            if (stepTimer >= 0.5)
            {
                world.PlaySoundAt(stepSound, entity.Pos.X, entity.Pos.Y, entity.Pos.Z,null,true,20f,0.5f);
                stepTimer = 0;
            }

            return base.ContinueExecute(dt); ;

        }
        public AiTaskLoudDrifterWander(EntityAgent entity) : base(entity)
        {

        }
    }

    public class AiTaskLoudDrifterSeekEntity : AiTaskSeekEntity
    {

        public AssetLocation stepSound = new AssetLocation("game", "sounds/walk/lava");
        public float stepTimer = new float();


        public override bool ContinueExecute(float dt)
        {
            stepTimer += dt;

            if (stepTimer >= 0.4)
            {
                world.PlaySoundAt(stepSound, entity.Pos.X, entity.Pos.Y, entity.Pos.Z, null, true, 20f, 0.5f);
                stepTimer = 0;
            }

            return base.ContinueExecute(dt); ;

        }
        public AiTaskLoudDrifterSeekEntity(EntityAgent entity) : base(entity)
        {

        }
    }

    public class AiTaskLoudDrifterFleeEntity : AiTaskFleeEntity
    {

        public AssetLocation stepSound = new AssetLocation("game", "sounds/walk/lava");
        public float stepTimer = new float();


        public override bool ContinueExecute(float dt)
        {
            stepTimer += dt;

            if (stepTimer >= 0.4)
            {
                world.PlaySoundAt(stepSound, entity.Pos.X, entity.Pos.Y, entity.Pos.Z, null, true, 20f, 0.5f);
                stepTimer = 0;
            }

            return base.ContinueExecute(dt); ;

        }
        public AiTaskLoudDrifterFleeEntity(EntityAgent entity) : base(entity)
        {

        }
    }





    public class AiTaskLoudWander : AiTaskWander
    {
        public AssetLocation stepSound = new AssetLocation("game", "sounds/walk/gravel3");
        public float stepTimer = new float();

        public override bool ContinueExecute(float dt)
        {
            stepTimer += dt;

            if (stepTimer >= 1)
            {
                world.PlaySoundAt(stepSound, entity.Pos.X, entity.Pos.Y, entity.Pos.Z);
                stepTimer = 0;
            }

            return base.ContinueExecute(dt); ; 

        }

        public AiTaskLoudWander(EntityAgent entity) : base(entity)
        {

        }
    }

    public class AiTaskLoudFleeEntity : AiTaskFleeEntity
    {
        public AssetLocation stepSound = new AssetLocation("game", "sounds/walk/gravel3");
        public float stepTimer = new float();
        public override bool ContinueExecute(float dt)
        {
            stepTimer += dt;

            if (stepTimer >= 0.3)
            {
                world.PlaySoundAt(stepSound, entity.Pos.X, entity.Pos.Y, entity.Pos.Z);
                stepTimer = 0;
            }

            return base.ContinueExecute(dt); ;

        }
        public AiTaskLoudFleeEntity(EntityAgent entity) : base(entity)
        {

        }
    }

    public class AiTaskLoudSeekEntity : AiTaskSeekEntity
    {
        public AssetLocation stepSound = new AssetLocation("game", "sounds/walk/gravel3");
        public float stepTimer = new float();
        public override bool ContinueExecute(float dt)
        {
            stepTimer += dt;

            if (stepTimer >= 0.3)
            {
                world.PlaySoundAt(stepSound, entity.Pos.X, entity.Pos.Y, entity.Pos.Z);
                stepTimer = 0;
            }

            return base.ContinueExecute(dt); ;

        }
        public AiTaskLoudSeekEntity(EntityAgent entity) : base(entity)
        {

        }
    }




    public class AiTaskSilentWander : AiTaskWander 
    {
        public AiTaskSilentWander(EntityAgent entity) : base(entity)
        {

        }
    }

    public class AiTaskSilentFleeEntity : AiTaskFleeEntity
    {
        public AiTaskSilentFleeEntity(EntityAgent entity) : base(entity)
        {

        }
    }

    public class AiTaskSilentSeekEntity : AiTaskSeekEntity
    {
        public AiTaskSilentSeekEntity(EntityAgent entity) : base(entity)
        {

        }
    }
}
